/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.62 Revision 1.127
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.62 2010/01/21 05:57:09 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.127 2012/05/02 17:09:17 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
16 28
17MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
20else 31
21 MY_P=qt-x11-opensource-src-${MY_PV} 32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH="${PV%.9999}"
37 ;;
38 release)
39 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
40 ;;
41esac
42
43IUSE="aqua debug pch"
44if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then
45 IUSE+=" +exceptions"
22fi 46fi
47if version_is_at_least 4.8; then
48 IUSE+=" c++0x qpa"
49fi
23 50
24HOMEPAGE="http://qt.nokia.com/" 51DEPEND="virtual/pkgconfig"
25SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 52if [[ ${QT4_BUILD_TYPE} == live ]]; then
26 53 DEPEND+=" dev-lang/perl"
27LICENSE="|| ( LGPL-2.1 GPL-3 )" 54fi
28IUSE="debug pch aqua"
29 55
30RDEPEND=" 56RDEPEND="
31 !<x11-libs/qt-assistant-${PV} 57 !<x11-libs/qt-assistant-${PV}
32 !>x11-libs/qt-assistant-${PV}-r9999 58 !>x11-libs/qt-assistant-${PV}-r9999
59 !<x11-libs/qt-bearer-${PV}
60 !>x11-libs/qt-bearer-${PV}-r9999
33 !<x11-libs/qt-core-${PV} 61 !<x11-libs/qt-core-${PV}
34 !>x11-libs/qt-core-${PV}-r9999 62 !>x11-libs/qt-core-${PV}-r9999
35 !<x11-libs/qt-dbus-${PV} 63 !<x11-libs/qt-dbus-${PV}
36 !>x11-libs/qt-dbus-${PV}-r9999 64 !>x11-libs/qt-dbus-${PV}-r9999
65 !<x11-libs/qt-declarative-${PV}
66 !>x11-libs/qt-declarative-${PV}-r9999
37 !<x11-libs/qt-demo-${PV} 67 !<x11-libs/qt-demo-${PV}
38 !>x11-libs/qt-demo-${PV}-r9999 68 !>x11-libs/qt-demo-${PV}-r9999
39 !<x11-libs/qt-gui-${PV} 69 !<x11-libs/qt-gui-${PV}
40 !>x11-libs/qt-gui-${PV}-r9999 70 !>x11-libs/qt-gui-${PV}-r9999
71 !<x11-libs/qt-multimedia-${PV}
72 !>x11-libs/qt-multimedia-${PV}-r9999
41 !<x11-libs/qt-opengl-${PV} 73 !<x11-libs/qt-opengl-${PV}
42 !>x11-libs/qt-opengl-${PV}-r9999 74 !>x11-libs/qt-opengl-${PV}-r9999
75 !<x11-libs/qt-openvg-${PV}
76 !>x11-libs/qt-openvg-${PV}-r9999
43 !<x11-libs/qt-phonon-${PV} 77 !<x11-libs/qt-phonon-${PV}
44 !>x11-libs/qt-phonon-${PV}-r9999 78 !>x11-libs/qt-phonon-${PV}-r9999
45 !<x11-libs/qt-qt3support-${PV} 79 !<x11-libs/qt-qt3support-${PV}
46 !>x11-libs/qt-qt3support-${PV}-r9999 80 !>x11-libs/qt-qt3support-${PV}-r9999
47 !<x11-libs/qt-script-${PV} 81 !<x11-libs/qt-script-${PV}
60 94
61S=${WORKDIR}/${MY_P} 95S=${WORKDIR}/${MY_P}
62 96
63# @FUNCTION: qt4-build_pkg_setup 97# @FUNCTION: qt4-build_pkg_setup
64# @DESCRIPTION: 98# @DESCRIPTION:
65# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 99# Sets up PATH and LD_LIBRARY_PATH.
66qt4-build_pkg_setup() { 100qt4-build_pkg_setup() {
67 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 101 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
68 102
103 # Protect users by not allowing downgrades between releases
104 # Downgrading revisions within the same release should be allowed
105 if has_version '>'${CATEGORY}/${P}-r9999; then
106 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
107 eerror
108 eerror "Sanity check to keep you from breaking your system:"
109 eerror " Downgrading Qt is completely unsupported and will break your system!"
110 eerror
111 die "aborting to save your system"
112 else
113 ewarn "Downgrading Qt is completely unsupported and will break your system!"
114 fi
115 fi
116
117 if [[ ${PN} == qt-webkit ]]; then
118 eshopts_push -s extglob
119 if is-flagq '-g?(gdb)?([1-9])'; then
120 echo
121 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
122 ewarn "You may experience really long compilation times and/or increased memory usage."
123 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
124 ewarn "For more info check out bug #307861"
125 echo
126 fi
127 eshopts_pop
128 fi
69 129
70 PATH="${S}/bin${PATH:+:}${PATH}" 130 PATH="${S}/bin${PATH:+:}${PATH}"
71 if [[ ${CHOST} != *-darwin* ]]; then 131 if [[ ${CHOST} != *-darwin* ]]; then
72 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 132 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
73 else 133 else
74 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}" 134 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
75 # on mac we *need* src/gui/kernel/qapplication_mac.cpp for platfrom 135 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
76 # detection since the x11-headers package b0rkens the header 136 # platform detection. Note: needs to come before any directories to
77 # installation, we have to extract src/ and include/ completely on mac 137 # avoid extract failure.
78 # tools is needed for qt-demo and some others 138 [[ ${CHOST} == *-apple-darwin* ]] && \
79 QT4_EXTRACT_DIRECTORIES+=" src include" 139 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
80
81 if [[ ${PN} == qt-demo || ${PN} == qt-qt3support || ${PN} == qt-webkit ]]; then
82 QT4_EXTRACT_DIRECTORIES+=" tools" 140 ${QT4_EXTRACT_DIRECTORIES}"
83 fi
84 fi
85
86 # Make sure ebuilds use the required EAPI
87 if [[ ${EAPI} != [23] ]]; then
88 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
89 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
90 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
91 die "qt4-build eclass requires EAPI=2 or EAPI=3"
92 fi 141 fi
93 142
94 if ! version_is_at_least 4.1 $(gcc-version); then 143 if ! version_is_at_least 4.1 $(gcc-version); then
95 ewarn "Using a GCC version lower than 4.1 is not supported!" 144 ewarn "Using a GCC version lower than 4.1 is not supported."
96 echo
97 ebeep 3
98 fi 145 fi
99} 146}
100 147
101# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 148# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
102# @DESCRIPTION: 149# @DESCRIPTION:
103# Arguments for build_target_directories. Takes the directories, in which the 150# Arguments for build_target_directories. Takes the directories in which the
104# code should be compiled. This is a space-separated list 151# code should be compiled. This is a space-separated list.
105 152
106# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 153# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
107# @DESCRIPTION: 154# @DESCRIPTION:
108# Space separated list including the directories that will be extracted from Qt 155# Space-separated list including the directories that will be extracted from
109# tarball 156# Qt tarball.
110 157
111# @FUNCTION: qt4-build_src_unpack 158# @FUNCTION: qt4-build_src_unpack
112# @DESCRIPTION: 159# @DESCRIPTION:
113# Unpacks the sources 160# Unpacks the sources.
114qt4-build_src_unpack() { 161qt4-build_src_unpack() {
115 setqtenv 162 setqtenv
116 local target targets= 163
164 case ${QT4_BUILD_TYPE} in
165 live)
166 git-2_src_unpack
167 ;;
168 release)
169 local tarball="${MY_P}.tar.gz" target= targets=
117 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 170 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
118 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 171 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
119 ${QT4_EXTRACT_DIRECTORIES}; do 172 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
173 do
120 targets+=" ${MY_P}/${target}" 174 targets+="${MY_P}/${target} "
121 done 175 done
122 176
123 echo tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 177 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
124 tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 178 tar -xzf "${DISTDIR}/${tarball}" ${targets}
179 eend $? || die "failed to unpack"
180 ;;
181 esac
125} 182}
126 183
127# @ECLASS-VARIABLE: PATCHES 184# @ECLASS-VARIABLE: PATCHES
185# @DEFAULT_UNSET
128# @DESCRIPTION: 186# @DESCRIPTION:
129# In case you have patches to apply, specify them in PATCHES variable. Make sure 187# PATCHES array variable containing all various patches to be applied.
130# to specify the full path. This variable is necessary for src_prepare phase. 188# This variable is expected to be defined in global scope of ebuild.
131# example: 189# Make sure to specify the full path. This variable is utilised in
132# PATCHES="${FILESDIR}"/mypatch.patch 190# src_unpack/src_prepare phase, based on EAPI.
133# ${FILESDIR}"/mypatch2.patch"
134# 191#
192# @CODE
193# PATCHES=( "${FILESDIR}/mypatch.patch"
194# "${FILESDIR}/patches_folder/" )
195# @CODE
135 196
136# @FUNCTION: qt4-build_src_prepare 197# @FUNCTION: qt4-build_src_prepare
137# @DESCRIPTION: 198# @DESCRIPTION:
138# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 199# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
139# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 200# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
140qt4-build_src_prepare() { 201qt4-build_src_prepare() {
141 setqtenv 202 setqtenv
142 cd "${S}" 203
204 if [[ ${QT4_BUILD_TYPE} == live ]]; then
205 QTDIR="." ./bin/syncqt || die "syncqt failed"
206 fi
207
208 if version_is_at_least 4.7; then
209 # fix libX11 dependency on non X packages
210 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
211 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
212
213 qt_assistant_cleanup
214 fi
143 215
144 if use aqua; then 216 if use aqua; then
145 # provide a proper macx-g++-64 217 # provide a proper macx-g++-64
146 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 218 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
147 219
148 sed -e '/^CONFIG/s:app_bundle::' \ 220 sed -e '/^CONFIG/s:app_bundle::' \
149 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 221 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
150 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 222 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
151 fi 223 fi
152 224
153 if [[ ${PN} != qt-core ]]; then 225 if [[ ${PN} != qt-core ]]; then
154 skip_qmake_build_patch 226 skip_qmake_build
155 skip_project_generation_patch 227 skip_project_generation
156 symlink_binaries_to_buildtree 228 symlink_binaries_to_buildtree
157 fi 229 fi
158 230
159 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 231 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
160 # qmake bus errors with -O2 but -O3 works 232 # qmake bus errors with -O2 or -O3 but -O1 works
233 # Bug 373061
161 replace-flags -O2 -O3 234 replace-flags -O[23] -O1
162 fi 235 fi
163
164 # Bug 282984 && Bug 295530
165 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\n\1:" \
166 -i configure || die "sed qmake compilers failed"
167 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX):" \
168 -i config.tests/unix/compile.test || die "sed test compilers failed"
169 236
170 # Bug 178652 237 # Bug 178652
171 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 238 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
172 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 239 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
173 append-flags -fno-gcse 240 append-flags -fno-gcse
174 fi 241 fi
175 242
243 if use_if_iuse c++0x; then
244 echo
245 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
246 ewarn "this is an official standard, some of the reverse dependencies"
247 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
248 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
249 ewarn "disabled."
250 echo
251 append-flags -std=c++0x
252 fi
253
176 # Unsupported old gcc versions - hardened needs this :( 254 # Unsupported old gcc versions - hardened needs this :(
177 if [[ $(gcc-major-version) -lt 4 ]] ; then 255 if [[ $(gcc-major-version) -lt 4 ]]; then
178 ewarn "Appending -fno-stack-protector to CXXFLAGS" 256 ewarn "Appending -fno-stack-protector to CXXFLAGS"
179 append-cxxflags -fno-stack-protector 257 append-cxxflags -fno-stack-protector
180 # Bug 253127 258 # Bug 253127
181 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 259 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
182 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 260 -i mkspecs/common/g++.conf || die
183 fi 261 fi
184 262
185 # Bug 261632 263 # Bug 261632
186 if use ppc64; then 264 if use ppc64; then
187 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 265 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
188 append-flags -mminimal-toc 266 append-flags -mminimal-toc
189 fi 267 fi
190 268
269 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
270 sed -e "/^SYSTEM_VARIABLES=/i \
271 CC='$(tc-getCC)'\n\
272 CXX='$(tc-getCXX)'\n\
273 CFLAGS='${CFLAGS}'\n\
274 CXXFLAGS='${CXXFLAGS}'\n\
275 LDFLAGS='${LDFLAGS}'\n" \
276 -i configure \
277 || die "sed SYSTEM_VARIABLES failed"
278
279 # Respect CC, CXX, LINK and *FLAGS in config.tests
280 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
281 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
282 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
283 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
284 || die "sed config.tests failed"
285
286 # Strip predefined CFLAGS from mkspecs (bug 312689)
287 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
288
191 # Bug 172219 289 # Bug 172219
192 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 290 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
193 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
194 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
195 -e "s:X11R6/::" \
196 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
197 291
198 if [[ ${CHOST} != *-darwin* ]]; then 292 if [[ ${CHOST} == *-darwin* ]]; then
199 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
200 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
201 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
202 -i mkspecs/common/g++.conf || die "sed mkspecs/common/g++.conf failed"
203 else
204 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 293 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
205 # crippled (by design) :/ 294 # crippled (by design) :/
295 local mac_gpp_conf=
296 if [[ -f mkspecs/common/mac-g++.conf ]]; then
297 # qt < 4.8 has mac-g++.conf
298 mac_gpp_conf="mkspecs/common/mac-g++.conf"
299 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
300 # qt >= 4.8 has g++-macx.conf
301 mac_gpp_conf="mkspecs/common/g++-macx.conf"
302 else
303 die "no known conf file for mac found"
304 fi
305 sed \
206 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 306 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
207 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 307 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
208 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 308 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
209 -e "s:-arch\s\w*::g" \ 309 -e "s:-arch\s\w*::g" \
210 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 310 -i ${mac_gpp_conf} \
311 || die "sed ${mac_gpp_conf} failed"
211 312
212 # Fix configure's -arch settings that appear in qmake/Makefile and also 313 # Fix configure's -arch settings that appear in qmake/Makefile and also
213 # fix arch handling (automagically duplicates our -arch arg and breaks 314 # fix arch handling (automagically duplicates our -arch arg and breaks
214 # pch). Additionally disable Xarch support. 315 # pch). Additionally disable Xarch support.
316 local mac_gcc_confs="${mac_gpp_conf}"
317 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
318 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
319 fi
215 sed \ 320 sed \
216 -e "s:-arch i386::" \ 321 -e "s:-arch i386::" \
217 -e "s:-arch ppc::" \ 322 -e "s:-arch ppc::" \
218 -e "s:-arch x86_64::" \ 323 -e "s:-arch x86_64::" \
219 -e "s:-arch ppc64::" \ 324 -e "s:-arch ppc64::" \
220 -e "s:-arch \$i::" \ 325 -e "s:-arch \$i::" \
221 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 326 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
222 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 327 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
223 -e "s:-Xarch_x86_64::g" \ 328 -e "s:-Xarch_x86_64::g" \
224 -e "s:-Xarch_ppc64::g" \ 329 -e "s:-Xarch_ppc64::g" \
225 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 330 -i configure ${mac_gcc_confs} \
331 || die "sed -arch/-Xarch failed"
226 332
227 # On Snow Leopard don't fall back to 10.5 deployment target. 333 # On Snow Leopard don't fall back to 10.5 deployment target.
228 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 334 if [[ ${CHOST} == *-apple-darwin10 ]]; then
229 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 335 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
230 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 336 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
231 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 337 -i configure ${mac_gpp_conf} \
338 || die "sed deployment target failed"
232 fi 339 fi
233 fi 340 fi
234 341
235 # this one is needed for all systems with a separate -liconv, apart from 342 # this one is needed for all systems with a separate -liconv, apart from
236 # Darwin, for which the sources already cater for -liconv 343 # Darwin, for which the sources already cater for -liconv
237 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 344 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
238 sed \ 345 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
239 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
240 -i config.tests/unix/iconv/iconv.pro \ 346 -i config.tests/unix/iconv/iconv.pro \
241 || die "sed on iconv.pro failed" 347 || die "sed iconv.pro failed"
242 fi 348 fi
243 349
244 # we need some patches for Solaris 350 # we need some patches for Solaris
245 sed -i \
246 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 351 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
247 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 352 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
248 # use GCC over SunStudio 353 # use GCC over SunStudio
249 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 354 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
250 # don't flirt with non-Prefix stuff, we're quite possessive 355 # do not flirt with non-Prefix stuff, we're quite possessive
251 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 356 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
252 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 357 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
253 358
254 base_src_prepare 359 base_src_prepare
255} 360}
257# @FUNCTION: qt4-build_src_configure 362# @FUNCTION: qt4-build_src_configure
258# @DESCRIPTION: 363# @DESCRIPTION:
259# Default configure phase 364# Default configure phase
260qt4-build_src_configure() { 365qt4-build_src_configure() {
261 setqtenv 366 setqtenv
262 myconf="$(standard_configure_options) ${myconf}" 367
368 local conf="
369 -prefix ${QTPREFIXDIR}
370 -bindir ${QTBINDIR}
371 -libdir ${QTLIBDIR}
372 -docdir ${QTDOCDIR}
373 -headerdir ${QTHEADERDIR}
374 -plugindir ${QTPLUGINDIR}
375 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
376 -datadir ${QTDATADIR}
377 -translationdir ${QTTRANSDIR}
378 -sysconfdir ${QTSYSCONFDIR}
379 -examplesdir ${QTEXAMPLESDIR}
380 -demosdir ${QTDEMOSDIR}
381 -opensource -confirm-license
382 -shared -fast -largefile -stl -verbose
383 -nomake examples -nomake demos"
384
385 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
386 # $(tc-arch). Therefore we convert it to supported values.
387 case "$(tc-arch)" in
388 amd64|x64-*) conf+=" -arch x86_64" ;;
389 ppc-macos) conf+=" -arch ppc" ;;
390 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
391 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
392 x86-macos) conf+=" -arch x86" ;;
393 x86|x86-*) conf+=" -arch i386" ;;
394 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
395 hppa|sh) conf+=" -arch generic" ;;
396 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
397 esac
398
399 conf+=" -platform $(qt_mkspecs_dir)"
400
401 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
402
403 # debug/release
404 if use debug; then
405 conf+=" -debug"
406 else
407 conf+=" -release"
408 fi
409 conf+=" -no-separate-debug-info"
410
411 # exceptions USE flag
412 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
413
414 # disable RPATH on Qt >= 4.8 (bug 380415)
415 version_is_at_least 4.8 && conf+=" -no-rpath"
416
417 # precompiled headers don't work on hardened, where the flag is masked
418 conf+=" $(qt_use pch)"
419
420 # -reduce-relocations
421 # This flag seems to introduce major breakage to applications,
422 # mostly to be seen as a core dump with the message "QPixmap: Must
423 # construct a QApplication before a QPaintDevice" on Solaris.
424 # -- Daniel Vergien
425 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
263 426
264 # this one is needed for all systems with a separate -liconv, apart from 427 # this one is needed for all systems with a separate -liconv, apart from
265 # Darwin, for which the sources already cater for -liconv 428 # Darwin, for which the sources already cater for -liconv
266 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 429 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
267 myconf+=" -liconv" 430 conf+=" -liconv"
431 fi
268 432
269 if has glib ${IUSE//+} && use glib; then 433 if use_if_iuse glib; then
270 # use -I, -L and -l from configure
271 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 434 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
272 # avoid the -pthread argument 435 # avoid the -pthread argument
273 myconf+=" ${glibflags//-pthread}" 436 conf+=" ${glibflags//-pthread}"
274 unset glibflags 437 unset glibflags
275 fi 438 fi
276 439
440 if use_if_iuse qpa; then
441 echo
442 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
443 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
444 ewarn "disable it before reporting any bugs related to this useflag."
445 echo
446 conf+=" -qpa"
447 fi
448
277 if use aqua ; then 449 if use aqua; then
278 # On (snow) leopard use the new (frameworked) cocoa code. 450 # On (snow) leopard use the new (frameworked) cocoa code.
279 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 451 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
280 myconf+=" -cocoa -framework" 452 conf+=" -cocoa -framework"
453 # We need the source's headers, not the installed ones.
454 conf+=" -I${S}/include"
455 # Add hint for the framework location.
456 conf+=" -F${QTLIBDIR}"
281 457
282 # We are crazy and build cocoa + qt3support :-) 458 # We are crazy and build cocoa + qt3support :-)
283 if use qt3support; then 459 if use qt3support; then
284 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 460 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
285 -i configure 461 -i configure || die
286 fi 462 fi
287 463 else
288 # We need the source's headers, not the installed ones. 464 conf+=" -no-framework"
289 myconf+=" -I${S}/include"
290
291 # Add hint for the framework location.
292 myconf+=" -F${QTLIBDIR}"
293 fi 465 fi
294 else 466 else
295 # freetype2 include dir is non-standard, thus include it on configure 467 # freetype2 include dir is non-standard, thus pass it to configure
296 # use -I from configure
297 myconf+=" $(pkg-config --cflags freetype2)" 468 conf+=" $(pkg-config --cflags-only-I freetype2)"
298 fi 469 fi
299 470
471 conf+=" ${myconf}"
472 myconf=
473
300 echo ./configure ${myconf} 474 echo ./configure ${conf}
301 ./configure ${myconf} || die "./configure failed" 475 ./configure ${conf} || die "./configure failed"
302 myconf="" 476
477 prepare_directories ${QT4_TARGET_DIRECTORIES}
303} 478}
304 479
305# @FUNCTION: qt4-build_src_compile 480# @FUNCTION: qt4-build_src_compile
481# @DESCRIPTION:
306# @DESCRIPTION: Actual compile phase 482# Actual compile phase
307qt4-build_src_compile() { 483qt4-build_src_compile() {
308 setqtenv 484 setqtenv
309 485
310 build_directories ${QT4_TARGET_DIRECTORIES} 486 build_directories ${QT4_TARGET_DIRECTORIES}
311} 487}
312 488
489# @FUNCTION: qt4-build_src_test
490# @DESCRIPTION:
491# Runs tests only in target directories.
492qt4-build_src_test() {
493 # QtMultimedia does not have any test suite (bug #332299)
494 [[ ${PN} == qt-multimedia ]] && return
495
496 for dir in ${QT4_TARGET_DIRECTORIES}; do
497 emake -j1 check -C ${dir}
498 done
499}
500
313# @FUNCTION: fix_includes 501# @FUNCTION: fix_includes
314# @DESCRIPTION: 502# @DESCRIPTION:
315# For MacOSX we need to add some symlinks when frameworks are 503# For MacOS X we need to add some symlinks when frameworks are
316# being used, to avoid complications with some more or less stupid packages. 504# being used, to avoid complications with some more or less stupid packages.
317fix_includes() { 505fix_includes() {
318 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 506 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
507 local frw dest f h rdir
319 # Some packages tend to include <Qt/...> 508 # Some packages tend to include <Qt/...>
320 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 509 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
321 510
322 # Fake normal headers when frameworks are installed... eases life later on 511 # Fake normal headers when frameworks are installed... eases life later
323 local dest f 512 # on, make sure we use relative links though, as some ebuilds assume
513 # these dirs exist in src_install to add additional files
514 f=${QTHEADERDIR}
515 h=${QTLIBDIR}
516 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
517 f=${f#*/}
518 h=${h#*/}
519 done
520 rdir=${h}
521 f="../"
522 while [[ ${h} == */* ]] ; do
523 f="${f}../"
524 h=${h#*/}
525 done
526 rdir="${f}${rdir}"
527
324 for frw in "${D}${QTLIBDIR}"/*.framework; do 528 for frw in "${D}${QTLIBDIR}"/*.framework; do
325 [[ -e "${frw}"/Headers ]] || continue 529 [[ -e "${frw}"/Headers ]] || continue
326 f=$(basename ${frw}) 530 f=$(basename ${frw})
327 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 531 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
328 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 532 dosym "${rdir}"/${f}/Headers "${dest}"
329 533
330 # Link normal headers as well. 534 # Link normal headers as well.
331 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 535 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
332 h=$(basename ${hdr}) 536 h=$(basename ${hdr})
333 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 537 dosym "../${rdir}"/${f}/Headers/${h} \
538 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
334 done 539 done
335 done 540 done
336 fi 541 fi
337} 542}
338 543
340# @DESCRIPTION: 545# @DESCRIPTION:
341# Perform the actual installation including some library fixes. 546# Perform the actual installation including some library fixes.
342qt4-build_src_install() { 547qt4-build_src_install() {
343 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 548 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
344 setqtenv 549 setqtenv
550
345 install_directories ${QT4_TARGET_DIRECTORIES} 551 install_directories ${QT4_TARGET_DIRECTORIES}
346 install_qconfigs 552 install_qconfigs
347 fix_library_files 553 fix_library_files
348 fix_includes 554 fix_includes
555
556 # remove .la files since we are building only shared Qt libraries
557 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
349} 558}
350 559
351# @FUNCTION: setqtenv 560# @FUNCTION: setqtenv
561# @INTERNAL
352setqtenv() { 562setqtenv() {
353 # Set up installation directories 563 # Set up installation directories
354 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
355 QTPREFIXDIR=${EPREFIX}/usr 564 QTPREFIXDIR=${EPREFIX}/usr
356 QTBINDIR=${EPREFIX}/usr/bin 565 QTBINDIR=${EPREFIX}/usr/bin
357 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 566 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
358 QMAKE_LIBDIR_QT=${QTLIBDIR}
359 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 567 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
360 QTDATADIR=${EPREFIX}/usr/share/qt4
361 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 568 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
362 QTHEADERDIR=${EPREFIX}/usr/include/qt4 569 QTHEADERDIR=${EPREFIX}/usr/include/qt4
363 QTPLUGINDIR=${QTLIBDIR}/plugins 570 QTPLUGINDIR=${QTLIBDIR}/plugins
571 QTIMPORTDIR=${QTLIBDIR}/imports
572 QTDATADIR=${EPREFIX}/usr/share/qt4
573 QTTRANSDIR=${QTDATADIR}/translations
364 QTSYSCONFDIR=${EPREFIX}/etc/qt4 574 QTSYSCONFDIR=${EPREFIX}/etc/qt4
365 QTTRANSDIR=${QTDATADIR}/translations
366 QTEXAMPLESDIR=${QTDATADIR}/examples 575 QTEXAMPLESDIR=${QTDATADIR}/examples
367 QTDEMOSDIR=${QTDATADIR}/demos 576 QTDEMOSDIR=${QTDATADIR}/demos
577 QMAKE_LIBDIR_QT=${QTLIBDIR}
368 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 578 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
579
369 PLATFORM=$(qt_mkspecs_dir) 580 PLATFORM=$(qt_mkspecs_dir)
370 581
371 unset QMAKESPEC 582 unset QMAKESPEC
372} 583}
373 584
374# @FUNCTION: standard_configure_options
375# @DESCRIPTION:
376# Sets up some standard configure options, like libdir (if necessary), whether
377# debug info is wanted or not.
378standard_configure_options() {
379 local myconf=
380
381 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
382
383 # Disable visibility explicitly if gcc version isn't 4
384 if [[ $(gcc-major-version) -lt 4 ]]; then
385 myconf+=" -no-reduce-exports"
386 fi
387
388 # precompiled headers doesn't work on hardened, where the flag is masked.
389 myconf+=" $(qt_use pch)"
390
391 if use debug; then
392 myconf+=" -debug"
393 else
394 myconf+=" -release"
395 fi
396 myconf+=" -no-separate-debug-info"
397
398 use aqua && myconf+=" -no-framework"
399
400 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
401 # $(tc-arch). Therefore we convert it to supported values.
402 case "$(tc-arch)" in
403 amd64|x64-*) myconf+=" -arch x86_64" ;;
404 ppc-macos) myconf+=" -arch ppc" ;;
405 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
406 sparc|sparc-*) myconf+=" -arch sparc" ;;
407 x86-macos) myconf+=" -arch x86" ;;
408 x86|x86-*) myconf+=" -arch i386" ;;
409 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
410 hppa|sh) myconf+=" -arch generic" ;;
411 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
412 esac
413
414 # 4.6: build qt-core with exceptions or qt-xmlpatterns won't build
415 local exceptions=
416 case "${PV}" in
417 4.6.*)
418 if [[ ${PN} != "qt-core" ]] && [[ ${PN} != "qt-xmlpatterns" ]]; then
419 case "${PV}:${CHOST}" in
420 4.6.0*:*-darwin*)
421 : # http://bugreports.qt.nokia.com/browse/QTBUG-5909
422 # workaround for compilation error on OSX (qt-gui)
423 ;;
424 *)
425 exceptions="-no-exceptions"
426 ;;
427 esac
428 fi
429 ;;
430 *)
431 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
432 ;;
433 esac
434
435 # note about -reduce-relocations:
436 # That flag seems to introduce major breakage to applications,
437 # mostly to be seen as a core dump with the message "QPixmap: Must
438 # construct a QApplication before a QPaintDevice" on Solaris
439 # -- Daniel Vergien
440 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
441
442 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
443 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
444 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
445 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
446 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
447 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
448 ${exceptions}
449 -nomake examples -nomake demos"
450
451 echo "${myconf}"
452}
453
454# @FUNCTION: build_directories 585# @FUNCTION: prepare_directories
455# @USAGE: < directories > 586# @USAGE: < directories >
587# @INTERNAL
456# @DESCRIPTION: 588# @DESCRIPTION:
457# Compiles the code in $QT4_TARGET_DIRECTORIES 589# Generates Makefiles for the given list of directories.
458build_directories() { 590prepare_directories() {
459 for x in "$@"; do 591 for x in "$@"; do
460 pushd "${S}"/${x} >/dev/null 592 pushd "${S}"/${x} >/dev/null || die
593 einfo "Running qmake in: ${x}"
461 # avoid running over the maximum argument number, bug #299810 594 # avoid running over the maximum argument number, bug #299810
462 { 595 {
463 echo "${S}"/mkspecs/common/*.conf 596 echo "${S}"/mkspecs/common/*.conf
464 find "${S}" -name '*.pr[io]' 597 find "${S}" -name '*.pr[io]'
465 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 598 } | xargs sed -i \
599 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
600 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
601 || die
466 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 602 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
467 emake CC="@echo compiling \$< && $(tc-getCC)" \
468 CXX="@echo compiling \$< && $(tc-getCXX)" \
469 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed"
470 popd >/dev/null 603 popd >/dev/null || die
604 done
605}
606
607
608# @FUNCTION: build_directories
609# @USAGE: < directories >
610# @INTERNAL
611# @DESCRIPTION:
612# Compiles the code in the given list of directories.
613build_directories() {
614 for x in "$@"; do
615 pushd "${S}"/${x} >/dev/null || die
616 emake CC="$(tc-getCC)" \
617 CXX="$(tc-getCXX)" \
618 LINK="$(tc-getCXX)" || die "emake failed"
619 popd >/dev/null || die
471 done 620 done
472} 621}
473 622
474# @FUNCTION: install_directories 623# @FUNCTION: install_directories
475# @USAGE: < directories > 624# @USAGE: < directories >
625# @INTERNAL
476# @DESCRIPTION: 626# @DESCRIPTION:
477# run emake install in the given directories, which are separated by spaces 627# Runs emake install in the given directories, which are separated by spaces.
478install_directories() { 628install_directories() {
479 for x in "$@"; do 629 for x in "$@"; do
480 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 630 pushd "${S}"/${x} >/dev/null || die
481 emake INSTALL_ROOT="${D}" install || die "emake install failed" 631 emake INSTALL_ROOT="${D}" install || die "emake install failed"
482 popd >/dev/null || die "Can't popd from ${S}/${x}" 632 popd >/dev/null || die
483 done 633 done
484} 634}
485 635
486# @ECLASS-VARIABLE: QCONFIG_ADD 636# @ECLASS-VARIABLE: QCONFIG_ADD
487# @DESCRIPTION: 637# @DESCRIPTION:
497# @DESCRIPTION: 647# @DESCRIPTION:
498# List variables that should be defined at the top of QtCore/qconfig.h 648# List variables that should be defined at the top of QtCore/qconfig.h
499: ${QCONFIG_DEFINE:=} 649: ${QCONFIG_DEFINE:=}
500 650
501# @FUNCTION: install_qconfigs 651# @FUNCTION: install_qconfigs
652# @INTERNAL
653# @DESCRIPTION:
502# @DESCRIPTION: Install gentoo-specific mkspecs configurations 654# Install gentoo-specific mkspecs configurations.
503install_qconfigs() { 655install_qconfigs() {
504 local x 656 local x
505 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 657 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
506 for x in QCONFIG_ADD QCONFIG_REMOVE; do 658 for x in QCONFIG_ADD QCONFIG_REMOVE; do
507 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 659 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
518 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 670 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
519 fi 671 fi
520} 672}
521 673
522# @FUNCTION: generate_qconfigs 674# @FUNCTION: generate_qconfigs
523# @DESCRIPTION: Generates gentoo-specific configurations 675# @INTERNAL
676# @DESCRIPTION:
677# Generates gentoo-specific qconfig.{h,pri}.
524generate_qconfigs() { 678generate_qconfigs() {
525 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 679 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
526 local x qconfig_add qconfig_remove qconfig_new 680 local x qconfig_add qconfig_remove qconfig_new
527 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 681 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
528 [[ -f ${x} ]] || continue 682 [[ -f ${x} ]] || continue
529 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 683 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
530 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 684 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
542 696
543 # generate list of QT_CONFIG entries from the existing list 697 # generate list of QT_CONFIG entries from the existing list
544 # including qconfig_add and excluding qconfig_remove 698 # including qconfig_add and excluding qconfig_remove
545 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 699 for x in $(sed -n 's/^QT_CONFIG +=//p' \
546 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 700 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
547 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 701 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
548 done 702 done
549 703
550 # replace the existing QT_CONFIG list with qconfig_new 704 # replace the existing QT_CONFIG list with qconfig_new
551 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 705 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
552 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 706 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
576 fi 730 fi
577 fi 731 fi
578} 732}
579 733
580# @FUNCTION: qt4-build_pkg_postrm 734# @FUNCTION: qt4-build_pkg_postrm
735# @DESCRIPTION:
581# @DESCRIPTION: Generate configurations when the package is completely removed 736# Regenerate configuration when the package is completely removed.
582qt4-build_pkg_postrm() { 737qt4-build_pkg_postrm() {
583 generate_qconfigs 738 generate_qconfigs
584} 739}
585 740
586# @FUNCTION: qt4-build_pkg_postinst 741# @FUNCTION: qt4-build_pkg_postinst
742# @DESCRIPTION:
587# @DESCRIPTION: Generate configuration, plus throws a message about possible 743# Regenerate configuration, plus throw a message about possible
588# breakages and proposed solutions. 744# breakages and proposed solutions.
589qt4-build_pkg_postinst() { 745qt4-build_pkg_postinst() {
590 generate_qconfigs 746 generate_qconfigs
591
592 if [[ "${PN}" == "qt-core" ]]; then
593 echo
594 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
595 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
596 ewarn "should recompile the packages providing these plugins. Also, make sure you"
597 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
598 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
599 ewarn
600 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
601 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
602 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
603 ewarn "configuration."
604 ewarn
605 ewarn "For more information, see http://doc.trolltech.com/${PV%.*}/plugins-howto.html"
606 echo
607 fi
608} 747}
609 748
610# @FUNCTION: skip_qmake_build_patch 749# @FUNCTION: skip_qmake_build
750# @INTERNAL
611# @DESCRIPTION: 751# @DESCRIPTION:
612# Don't need to build qmake, as it's already installed from qt-core 752# Patches configure to skip qmake compilation, as it's already installed by qt-core.
613skip_qmake_build_patch() { 753skip_qmake_build() {
614 # Don't need to build qmake, as it's already installed from qt-core
615 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 754 sed -i -e "s:if true:if false:g" "${S}"/configure || die
616} 755}
617 756
618# @FUNCTION: skip_project_generation_patch 757# @FUNCTION: skip_project_generation
758# @INTERNAL
619# @DESCRIPTION: 759# @DESCRIPTION:
620# Exit the script early by throwing in an exit before all of the .pro files are scanned 760# Exit the script early by throwing in an exit before all of the .pro files are scanned.
621skip_project_generation_patch() { 761skip_project_generation() {
622 # Exit the script early by throwing in an exit before all of the .pro files are scanned
623 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 762 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
624 -i "${S}"/configure || die "Sed failed"
625} 763}
626 764
627# @FUNCTION: symlink_binaries_to_buildtree 765# @FUNCTION: symlink_binaries_to_buildtree
766# @INTERNAL
628# @DESCRIPTION: 767# @DESCRIPTION:
629# Symlink generated binaries to buildtree so they can be used during compilation 768# Symlinks generated binaries to buildtree, so they can be used during compilation time.
630# time
631symlink_binaries_to_buildtree() { 769symlink_binaries_to_buildtree() {
632 for bin in qmake moc uic rcc; do 770 for bin in qmake moc uic rcc; do
633 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 771 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
634 done 772 done
635} 773}
636 774
637# @FUNCTION: fix_library_files 775# @FUNCTION: fix_library_files
776# @INTERNAL
638# @DESCRIPTION: 777# @DESCRIPTION:
639# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 778# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
640# moves the *.pc-files into the pkgconfig directory 779# moves the *.pc files into the pkgconfig directory.
641fix_library_files() { 780fix_library_files() {
781 local libfile
642 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 782 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
643 if [[ -e ${libfile} ]]; then 783 if [[ -e ${libfile} ]]; then
644 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 784 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
645 fi 785 fi
646 done 786 done
647 787
648 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 788 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
649 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 789 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
650 if [[ -e ${libfile} ]]; then 790 if [[ -e ${libfile} ]]; then
651 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 791 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
652 792
653 # Move .pc files into the pkgconfig directory 793 # Move .pc files into the pkgconfig directory
654 dodir ${QTPCDIR#${EPREFIX}} 794 dodir ${QTPCDIR#${EPREFIX}}
655 mv ${libfile} "${D}"/${QTPCDIR}/ \ 795 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
656 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
657 fi 796 fi
658 done 797 done
659 798
660 # Don't install an empty directory 799 # Don't install an empty directory
661 rmdir "${D}"/${QTLIBDIR}/pkgconfig 800 rmdir "${D}"/${QTLIBDIR}/pkgconfig
662} 801}
663 802
664# @FUNCTION: qt_use 803# @FUNCTION: qt_use
665# @USAGE: < flag > [ feature ] [ enableval ] 804# @USAGE: < flag > [ feature ] [ enableval ]
666# @DESCRIPTION: 805# @DESCRIPTION:
667# This will echo "${enableval}-${feature}" if <flag> is enabled, or 806# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
668# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 807# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
669# will be used for that. If [enableval] is not specified, it omits the 808# will be used for that. If [enableval] is not specified, it omits the
670# assignment-part 809# "-${enableval}" part.
671qt_use() { 810qt_use() {
672 local flag=$1 811 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
673 local feature=$1
674 local enableval=
675
676 [[ -n $2 ]] && feature=$2
677 [[ -n $3 ]] && enableval=-$3
678
679 if use ${flag}; then
680 echo "${enableval}-${feature}"
681 else
682 echo "-no-${feature}"
683 fi
684} 812}
685 813
686# @FUNCTION: qt_mkspecs_dir 814# @FUNCTION: qt_mkspecs_dir
687# @RETURN: the specs-directory w/o path 815# @RETURN: the specs-directory w/o path
688# @DESCRIPTION: 816# @DESCRIPTION:
689# Allows us to define which mkspecs dir we want to use. 817# Allows us to define which mkspecs dir we want to use.
690qt_mkspecs_dir() { 818qt_mkspecs_dir() {
691 # Allows us to define which mkspecs dir we want to use.
692 local spec 819 local spec=
693 820
694 case ${CHOST} in 821 case "${CHOST}" in
695 *-freebsd*|*-dragonfly*) 822 *-freebsd*|*-dragonfly*)
696 spec=freebsd ;; 823 spec=freebsd ;;
697 *-openbsd*) 824 *-openbsd*)
698 spec=openbsd ;; 825 spec=openbsd ;;
699 *-netbsd*) 826 *-netbsd*)
710 *-solaris*) 837 *-solaris*)
711 spec=solaris ;; 838 spec=solaris ;;
712 *-linux-*|*-linux) 839 *-linux-*|*-linux)
713 spec=linux ;; 840 spec=linux ;;
714 *) 841 *)
715 die "Unknown CHOST, no platform choosen." 842 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
716 esac 843 esac
717 844
718 CXX=$(tc-getCXX) 845 case "$(tc-getCXX)" in
719 if [[ ${CXX} == *g++* ]]; then 846 *g++*)
720 spec+=-g++ 847 spec+=-g++ ;;
721 elif [[ ${CXX} == *icpc* ]]; then 848 *icpc*)
722 spec+=-icc 849 spec+=-icc ;;
723 else 850 *)
724 die "Unknown compiler ${CXX}." 851 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
725 fi 852 esac
726 if [[ -n ${LIBDIR/lib} ]]; then
727 spec+=-${LIBDIR/lib}
728 fi
729 853
730 # Add -64 for 64bit profiles 854 # Add -64 for 64bit profiles
731 if use x64-freebsd || 855 if use x64-freebsd ||
732 use amd64-linux || 856 use amd64-linux ||
733 use x64-macos || 857 use x64-macos ||
738 fi 862 fi
739 863
740 echo "${spec}" 864 echo "${spec}"
741} 865}
742 866
867# @FUNCTION: qt_assistant_cleanup
868# @INTERNAL
869# @DESCRIPTION:
870# Tries to clean up tools.pro for qt-assistant ebuilds.
871# Meant to be called in src_prepare().
872# Since Qt 4.7.4 this function is a no-op.
873qt_assistant_cleanup() {
874 # apply patching to qt-assistant ebuilds only
875 [[ ${PN} != qt-assistant ]] && return
876
877 # no longer needed for 4.7.4 and later
878 version_is_at_least 4.7.4 && return
879
880 # different versions (and branches...) may need different handling,
881 # add a case if you need special handling
882 case "${MY_PV_EXTRA}" in
883 *kde-qt*)
884 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
885 -e "/mac/,/^embedded.*makeqpf$/d" \
886 -i tools/tools.pro || die "patching tools.pro failed"
887 ;;
888 *)
889 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
890 -e "/mac/,/^embedded.*makeqpf$/d" \
891 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
892 -i tools/tools.pro || die "patching tools.pro failed"
893 ;;
894 esac
895}
896
897# @FUNCTION: qt_nolibx11
898# @INTERNAL
899# @DESCRIPTION:
900# Ignore X11 tests for packages that don't need X libraries installed.
901qt_nolibx11() {
902 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
903 die "x11 check sed failed"
904}
905
743EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst 906EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.62  
changed lines
  Added in v.1.127

  ViewVC Help
Powered by ViewVC 1.1.20